// SplitterTownFrame.h

#pragma once
#ifndef INC_SPLITTERTOWNFRAME
#define INC_SPLITTERTOWNFRAME

/////////////////////////////////////////////////////////////////////////////
// TreeView

class CMyTreeView: public CViewWindowImpl<CMyTreeView, CTreeViewCtrl, CWinTraitsOR<WS_BORDER|WS_CHILD|WS_CLIPSIBLINGS|WS_VSCROLL|WS_HSCROLL|WS_VISIBLE|WS_TABSTOP |TVS_EDITLABELS|TVS_HASLINES|TVS_LINESATROOT|TVS_HASBUTTONS|TVS_SHOWSELALWAYS> >
{
public:	
	typedef CViewWindowImpl<CMyTreeView, CTreeViewCtrl, CWinTraitsOR<WS_BORDER|WS_CHILD|WS_CLIPSIBLINGS|WS_VSCROLL|WS_HSCROLL|WS_VISIBLE|WS_TABSTOP |TVS_EDITLABELS|TVS_HASLINES|TVS_LINESATROOT|TVS_HASBUTTONS|TVS_SHOWSELALWAYS> > baseclass;
	BEGIN_MSG_MAP(CMyTreeView)
		MESSAGE_HANDLER(WM_CREATE, OnCreate)
		CHAIN_MSG_MAP(baseclass)
	END_MSG_MAP()

	LRESULT OnCreate(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		DefWindowProc();
		//TODO Add your data
		HTREEITEM hParent = InsertItem(_T("To compute is human..."), 0, 0);
		HTREEITEM h1 = InsertItem(_T("To recurse is divine!"), hParent, 0);
		HTREEITEM h2 = InsertItem(_T("To Err is human..."), h1, 0);
		InsertItem(_T("To Err again & again is divine!"), h2, 0);
		return 0L;
	}
};

/////////////////////////////////////////////////////////////////////////////
// ListView

class CMyListView: public CViewWindowImpl<CMyListView, CListViewCtrl, CWinTraitsOR<LVS_REPORT | LVS_EX_GRIDLINES | LVS_NOSORTHEADER | LVS_SINGLESEL, WS_EX_WINDOWEDGE> > 
{
public:	
	typedef CViewWindowImpl<CMyListView, CListViewCtrl, CWinTraitsOR<LVS_REPORT | LVS_EX_GRIDLINES | LVS_NOSORTHEADER | LVS_SINGLESEL, WS_EX_WINDOWEDGE> >  baseclass;
	BEGIN_MSG_MAP(CMyListView)
		MESSAGE_HANDLER(WM_CREATE, OnCreate)
		CHAIN_MSG_MAP(baseclass)
	END_MSG_MAP()
	
	LRESULT OnCreate(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		DefWindowProc();
		
		//TODO Add your data
		AddColumn(_T("Name                   "), 0);
		AddColumn(_T("Value                        "), 1);

		AddItem(0,0,_T("Welcome "));
		SetItemText(0, 0,_T("Welcome"));
		AddItem(1,0,_T("To"));
		SetItemText(1, 0,_T("To") );
		AddItem(2,0,_T("SplitterTown"));
		SetItemText(2, 0,_T("SplitterTown") );
		
		return 0L;
	}
};

/////////////////////////////////////////////////////////////////////////////
// Right Pane of the SplitterView 

class CMyRightView: public CViewWindowImpl<CMyRightView>
{
public:
	CMyRightView():m_ListViewTop(this){}	
public:
	BEGIN_MSG_MAP(CMyRightView)
		MESSAGE_HANDLER(WM_CREATE, OnCreate)
		MESSAGE_HANDLER(WM_SIZE, OnSize)		
		CHAIN_MSG_MAP(CViewWindowImpl<CMyRightView>)
	END_MSG_MAP()

	LRESULT OnCreate(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		m_ListViewBottom.Create(m_hWnd,CWindow::rcDefault);
		m_ListViewTop.Create(m_hWnd,CWindow::rcDefault);
		return 0L;
	}
	
	LRESULT GetSiblingWnd(CWindow& wndSibling)
	{
		if(m_ListViewBottom.m_hWnd)
		{
			wndSibling = m_ListViewBottom.m_hWnd;
			return 0;
		}
		return -1;
	}

	LRESULT OnSize(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		DefWindowProc();
	
		RECT rc; GetClientRect(&rc);

		m_ListViewTop.RepositionSplitters(&rc);
		return 0L;
	}
	
	typedef CSplitterImpl< CMyRightView, CMyListView,false> CSplitterView;
	
	CSplitterView			m_ListViewTop;
	CMyListView				m_ListViewBottom;
};

/////////////////////////////////////////////////////////////////////////////
// Left Pane of the SplitterView 

class CMyView: public CViewWindowImpl<CMyView>
{
public:
	typedef CViewWindowImpl<CMyView> baseClass;
	CMyView():m_LeftView(this){}	
public:
	BEGIN_MSG_MAP(CMyView)
		MESSAGE_HANDLER(WM_CREATE, OnCreate)
		MESSAGE_HANDLER(WM_SIZE, OnSize)		
		CHAIN_MSG_MAP(baseClass)
	END_MSG_MAP()

	LRESULT OnCreate(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		m_RightView.Create(m_hWnd,CWindow::rcDefault);
		m_LeftView.Create(m_hWnd,CWindow::rcDefault);

		return 0L;
	}
	
	LRESULT OnSize(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		DefWindowProc();
	
		RECT rc; GetClientRect(&rc);
		
		m_LeftView.RepositionSplitters(&rc);
		m_RightView.GetClientRect(&rc);
		m_RightView.m_ListViewTop.RepositionSplitters(&rc);
		return 0L;
	}
	LRESULT GetSiblingWnd(CWindow& wndSibling)
	{
		if(m_RightView.m_hWnd)
		{
			wndSibling = m_RightView.m_hWnd;
			return 0;
		}
		return -1;
	}
	
	typedef CSplitterImpl< CMyView, CMyTreeView> CSplitterView;

private:
	CSplitterView			m_LeftView;
	CMyRightView			m_RightView;
};

/////////////////////////////////////////////////////////////////////////////
// App Frame

class CMySplitterTownFrame: public CFrameWindowImpl<CMySplitterTownFrame>
{
public:
	typedef CFrameWindowImpl<CMySplitterTownFrame> baseClass;
	BEGIN_MSG_MAP(CMySplitterTownFrame)
		MESSAGE_HANDLER(WM_CREATE, OnCreate)
		MESSAGE_HANDLER(WM_SETFOCUS, OnSetFocus)
		MESSAGE_HANDLER(WM_SIZE, OnSize)		
		COMMAND_ID_HANDLER(ID_APP_EXIT, OnAppExit) 
		COMMAND_ID_HANDLER(ID_APP_ABOUT, OnAbout) 
		CHAIN_MSG_MAP(baseClass)
	END_MSG_MAP()

	LRESULT OnCreate(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		//Create the Statusbar
		m_wndStatusBar.Create(m_hWnd,CWindow::rcDefault);
		
		//Create the View
		m_View.Create(m_hWnd,CWindow::rcDefault);

		//Fill an array of Toolbar buttons
		TBBUTTON tbButtons[] = 
		{
			{ 0,	ID_FILE_NEW,						TBSTATE_ENABLED				,TBSTYLE_BUTTON, 0L, 0},
			{ 1,	ID_FILE_OPEN,						TBSTATE_ENABLED				,TBSTYLE_BUTTON, 0L, 0},
			{ 2,	ID_FILE_SAVE,						TBSTATE_ENABLED				,TBSTYLE_BUTTON, 0L, 0},
			{ 3,	ID_EDIT_CUT,						TBSTATE_ENABLED				,TBSTYLE_BUTTON, 0L, 0},
			{ 4,	ID_EDIT_COPY,						TBSTATE_ENABLED				,TBSTYLE_BUTTON, 0L, 0},
			{ 5,	ID_EDIT_PASTE,						TBSTATE_ENABLED				,TBSTYLE_BUTTON, 0L, 0},
			{ 6,	ID_APP_ABOUT,						TBSTATE_ENABLED				,TBSTYLE_BUTTON, 0L, 0}
		};

		//Create the Toolbar
		m_wndToolBar.Create(m_hWnd,CWindow::rcDefault,tbButtons,7,IDR_MAINFRAME);
		
		return 0L;
	}

	LRESULT OnSetFocus(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		m_View.SetFocus();
		return 0L;
	}

	LRESULT OnSize(UINT  uMsg , WPARAM  wParam , LPARAM  lParam , BOOL&  bHandled)
	{
		bHandled = ResizeElements();
		return 0L;
	}
	LRESULT OnAppExit(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
	{	
		DestroyWindow(); //Will make the Frame call PostQuitMessage
		return 0L;
	}
	LRESULT OnAbout(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		CSimpleDialog<IDD_ABOUT> dlg;
		dlg.DoModal();
		return 0L;
	}
	
public://virtuals
	BOOL ResizeElements()
	{
		m_wndStatusBar.SendMessage(WM_SIZE);
		RECT rc,rcToolPanel,rcStatus;
		GetClientRect(&rc);
		
		GetClientRect(&rc);
		m_wndToolBar.SetWindowPos(NULL,rc.left, rc.top, rc.right - rc.left,30,SWP_NOZORDER | SWP_NOACTIVATE);
				
		m_wndToolBar.GetWindowRect(&rcToolPanel);
		rc.top +=  (rcToolPanel.bottom - rcToolPanel.top);

		m_wndStatusBar.GetWindowRect(&rcStatus);
		rc.bottom -= (rcStatus.bottom - rcStatus.top);
		
		m_View.SetWindowPos(NULL, rc.left, rc.top,rc.right - rc.left, rc.bottom - rc.top,
							SWP_NOZORDER | SWP_NOACTIVATE);

		return TRUE;
	}

private:
	CMyView				m_View;
	CToolBar			m_wndToolBar;		
	CStatusBar			m_wndStatusBar;	
};

#endif // INC_SPLITTERTOWNFRAME
